local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38535 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Kael'thas Sunstrider"]

local Kaelthas = ThreatLib:GetModule("NPCCore"):NewModule(c)

local phaseTriggerStrings = {
	["Thaladred"] = {
		["enUS"] = "Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!",
		["deDE"] = nil,
		["frFR"] = "Impressionnant. Voyons comment tiendront vos nerfs face  l'Assombrisseur, Thaladred!",
		["koKR"] = "??? ??? ?????? ??? ??? ??? ???",
		["zhTW"] = nil
	},
	["Sanguinar"] = {
		["enUS"] = "You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!",
		["deDE"] = nil,
		["frFR"] = "Vous avez tenu tte  certains de mes plus talentueux conseillers mais personne ne peut rsister  la puissance du Marteau de sang. Je vous prsente, le seigneur Sanguinar!",
		["koKR"] = "??? ???? ??? ?? ????. ?? ? ??? ?? ??? ??? ??? ? ??. ???, ?? ?????!",
		["zhTW"] = nil
	},
	["Capernian"] = {
		["enUS"] = "Capernian will see to it that your stay here is a short one.",
		["deDE"] = nil,
		["frFR"] = "Capernian fera en sorte que votre sjour ici ne se prolonge pas.",
		["koKR"] = "????, ??? ?? ? ?? ???? ? ??.",
		["zhTW"] = nil
	},
	["Telonicus"] = {
		["enUS"] = "Well done, you have proven worthy to test your skills against my master engineer, Telonicus.",
		["deDE"] = nil,
		["frFR"] = "Bien, vous tes digne de mesurer votre talent  celui de mon matre ingnieur, Telonicus.",
		["koKR"] = "??, ? ?? ???? ????? ?????? ??? ?????.",
		["zhTW"] = nil
	},
	["AllAdvisors"] = {
		["enUS"] = "Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor.",
		["deDE"] = nil,
		["frFR"] = "Peut-tre vous ai-je sous-estims. Il ne serait pas trs loyal de vous faire combattre mes quatres conseillers en mme temps, mais mon peuple n'a jamais t trat avec loyaut. Je ne fais que rendre la politesse.",
		["koKR"] = "???? ?????? ??. ??? ???? ????? ? ???? ???. ?? ??? ??? ??? ?? ? ??? ????. ?? ?? ?????.",
		["zhTW"] = nil
	},
	["Weapons"] = {
		["enUS"] = "As you see, I have many weapons in my arsenal....",
		["deDE"] = nil,
		["frFR"] = "Comme vous le voyez, j'ai plus d'une corde  mon arc",
		["koKR"] = "???? ? ???? ??? ??? ?? ??.",
		["zhTW"] = nil
	},
	["Kael"] = {
		["enUS"] = "Alas, sometimes one must take matters into one's own hands. Balamore shanal!",
		["deDE"] = nil,
		["frFR"] = "Il est hlas parfois ncessaire de prendre les choses en main soi-mme. Balamore shanal!",
		["koKR"] = nil,
		["zhTW"] = nil
	}
}

local weaponNames = {
	["Devastation"] = {
		["enUS"] = "Devastation",
		["deDE"] = nil,
		["frFR"] = "Dvastation",
		["koKR"] = "??? ??",
		["zhTW"] = nil
	},
	["Cosmic Infuser"] = {
		["enUS"] = "Cosmic Infuser",
		["deDE"] = nil,
		["frFR"] = "Bton d'infusion cosmique",
		["koKR"] = "??? ???",
		["zhTW"] = nil
	},
	["Infinity Blades"] = {
		["enUS"] = "Infinity Blades",
		["deDE"] = nil,
		["frFR"] = "Lames d'infinit",
		["koKR"] = "??? ??",
		["zhTW"] = nil
	},
	["Staff of Disintegration"] = {
		["enUS"] = "Staff of Disintegration",
		["deDE"] = nil,
		["frFR"] = "Bton de dsintgration",
		["koKR"] = "?? ??? ???",
		["zhTW"] = nil
	},
	["Warp Slicer"] = {
		["enUS"] = "Warp Slicer",
		["deDE"] = nil,
		["frFR"] = "Tranchoir dimensionnel",
		["koKR"] = "??? ???",
		["zhTW"] = nil
	},
	["Netherstrand Longbow"] = {
		["enUS"] = "Netherstrand Longbow",
		["deDE"] = nil,
		["frFR"] = "Arc long brins-de-Nant",
		["koKR"] = "???? ??",
		["zhTW"] = nil
	},
	["Phaseshift Bulwark"] = {
		["enUS"] = "Phaseshift Bulwark",
		["deDE"] = nil,
		["frFR"] = "Rempart de dphasage",
		["koKR"] = "?? ??? ????",
		["zhTW"] = nil
	},
}

local thaladredTrigger = phaseTriggerStrings["Thaladred"][_G.GetLocale()]
local sanguinarTrigger = phaseTriggerStrings["Sanguinar"][_G.GetLocale()]
local capernianTrigger = phaseTriggerStrings["Capernian"][_G.GetLocale()]
local telonicusTrigger = phaseTriggerStrings["Telonicus"][_G.GetLocale()]
local allAdvisorsTrigger = phaseTriggerStrings["AllAdvisors"][_G.Getlocale()]
local weaponTrigger = phaseTriggerStrings["Weapons"][_G.GetLocale()]
local kaelTrigger = phaseTriggerStrings["Kael"][_G.GetLocale()]

phaseTriggerStrings = nil

local weaponName = {
	["Devastation"] = weaponNames["Devastation"][_G.GetLocale()],
	["Cosmic Infuser"] = weaponNames["Cosmic Infuser"][_G.GetLocale()],
	["Infinity Blades"] = weaponNames["Infinity Blades"][_G.GetLocale()],
	["Staff of Disintigration"] = weaponNames["Staff of Disintigration"][_G.GetLocale()],
	["Warp Slicer"] = weaponNames["Warp Slicer"][_G.GetLocale()],
	["Netherstrand Longbow"] = weaponNames["Netherstrand Longbow"][_G.GetLocale()],
	["Phaseshift Bulwark"] = weaponNames["Phaseshift Bulwark"][_G.GetLocale()]
}

weaponNames = nil

local advisorDeathCount = 0
local weaponDeathCount = 0

function Kaelthas:Init()	
	self:RegisterCombatant(BB["Kael'thas Sunstrider"], true)
	self:RegisterCombatant(BB["Thaladred the Darkener"], self.advisorDeath)
	self:RegisterCombatant(BB["Lord Sanguinar"], self.advisorDeath)
	self:RegisterCombatant(BB["Grand Astromancer Capernian"], self.advisorDeath)
	self:RegisterCombatant(BB["Master Engineer Telonicus"], self.advisorDeath)
	
	if weaponName["Devastation"] and weaponName["Cosmic Infuser"] and weaponName["Infinity Blades"] and weaponName["Staff of Disintigration"] and weaponName["Warp Slicer"] and weaponName["Netherstrand Longbow"] and weaponName["Phaseshift Bulwark"] then
		self:RegisterCombatant(weaponName["Devastation"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Cosmic Infuser"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Infinity Blades"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Staff of Disintigration"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Warp Slicer"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Netherstrand Longbow"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Phaseshift Bulwark"], self.weaponDeath)
	end
	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], thaladredTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], sanguinarTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], capernianTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], telonicusTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], weaponTrigger, self.weaponTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], allAdvisorsTrigger, self.allAdvisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], kaelTrigger, self.kaelTransition)
end

function Kaelthas:StartFight()
	self:SetNumberOfMobs(1)
end

function Kaelthas:advisorDeath(victimName, killerName)
	self:WipeThreatOnMob(victimName)
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
	advisorDeathCount = advisorDeathCount + 1
end

function Kaelthas:weaponDeath(victimName, killerName)
	self:WipeThreatOnMob(victimName)
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
	weaponDeathCount = weaponDeathCount + 1
end

function Kaelthas:advisorTransition()
	self:SetNumberOfMobs(1)
	self:WipeRaidThreatOnMob(BB["Thaladred the Darkener"])
	self:WipeRaidThreatOnMob(BB["Lord Sanguinar"])
	self:WipeRaidThreatOnMob(BB["Grand Astromancer Capernian"])
	self:WipeRaidThreatOnMob(BB["Master Engineer Telonicus"])
end

function Kaelthas:weaponTransition()
	self:SetNumberOfMobs(7)
	weaponDeathCount = 0
end

function Kaelthas:allAdvisorTransition()
	if weaponDeathCount == 7 then
		self:SetNumberOfMobs(4)
	else
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 4)
	end
	advisorDeathCount = 0
	self:WipeRaidThreatOnMob(BB["Thaladred the Darkener"])
	self:WipeRaidThreatOnMob(BB["Lord Sanguinar"])
	self:WipeRaidThreatOnMob(BB["Grand Astromancer Capernian"])
	self:WipeRaidThreatOnMob(BB["Master Engineer Telonicus"])
end

function Kaelthas:kaelTransition()
	if weaponDeathCount == 7 and advisorDeathCount == 4 then
		self:SetNumberOfMobs(1)
	else
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 1)
	end
	self:WipeRaidThreatOnMob(BB["Kael'thas Sunstrider"])
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Kaelthas = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
